/* EVB-2478: setup.c */

#include "LPC24xx.h"
#include "StdTypes.h"
#include "startup.h"
#include "config.h"


/*----------- Gerte-Status-Variablen ----------------*/
dword  ExtRamSize;
bool   SD_CardDetected;
bool   SD_readonly;
int64  SD_CardSize;
int    SDCardTyp;     /* siehe sdio.h "Supported Memory Cards" */


void delay (long wielange)
{ long L;
  L = wielange;
  while (--L);
}


volatile dword  D;

long Do_Config (void)
{ dword* PDW;
  long   L;

  PINSEL0  = ValForPinsel0;
  PINSEL1  = ValForPinsel1;
  PINSEL2  = ValForPinsel2;
  PINSEL3  = ValForPinsel3;
  PINSEL4  = ValForPinsel4;
  PINSEL5  = ValForPinsel5;
  PINSEL6  = ValForPinsel6;
  PINSEL7  = ValForPinsel7;
  PINSEL8  = ValForPinsel8;
  PINSEL9  = ValForPinsel9;
  PINSEL10 = ValForPinsel10;
  PINSEL11 = ValForPinsel11;

  PINMODE0 = ValForPINMODE0;
  PINMODE1 = ValForPINMODE1;
  PINMODE2 = ValForPINMODE2;
  PINMODE3 = ValForPINMODE3;
  PINMODE4 = ValForPINMODE4;
  PINMODE5 = ValForPINMODE5;
  PINMODE6 = ValForPINMODE6;
  PINMODE7 = ValForPINMODE7;
  PINMODE8 = ValForPINMODE8;
  PINMODE9 = ValForPINMODE9;

/*----------- Pin I/O setzen -------------------------*/
  FIO1DIR |= 0x80000000;         // WPI (SD-karte) auf 0
  FIO1CLR  = 0x80000000;



  PCONP |= (1<<20);  // Power fr LCD einschalten
  LCD_CTRL = 0;      // erstmal alles aus

//  ExtRamBegin     = 0xA0000000;
  ExtRamSize      = 0;

/*----------- externer SDRAM --------------------------*/
  PCONP          |= (1<<11);  // Power fr EMC einschalten
  EMC_CTRL        = 1;        // EMC enable, Adressmirror aus, normal mode
  EMC_CONFIG      = 0;        //(0) Little Endian mode
  EMC_DYN_CTRL    = 2;        // wie nach Reset
  EMC_DYN_RP      = 1;        //(1) tRP    (mind. 20ns) auf (n+1) = 2 Takte = 33 ns
  EMC_DYN_RAS     = 4;        //(3) tRAS   (mind. 42ns) auf (n+1) = 4 Takte = 66 ns
  EMC_DYN_SREX    = 5;        // tSREX=tXSR (mind. 70ns) auf (n+1) = 6 Takte = 100 ns
  EMC_DYN_APR     = 1;        //(1) tAPR in Clocks (nicht gefunden)
  EMC_DYN_DAL     = 5;        // tDAL (CL=3) --> 5 Takte
  EMC_DYN_WR      = 1;        //(1) tWR (1 CLK+7ns) also (n+1) = 2 Takte
  EMC_DYN_RC      = 5;        // tRC    (mind. 70ns) auf (n+1) = 6 Takte = 100 ns
  EMC_DYN_RFC     = 5;        // tRFC   (mind. 70ns) auf (n+1) = 6 Takte = 100 ns
  EMC_DYN_XSR     = 5;        // tXSR   (mind. 70ns) auf (n+1) = 6 Takte = 100 ns
  EMC_DYN_RRD     = 1;        // tRRD   (mind. 14ns) auf (n+1) = 2 Takte = 33 ns
  EMC_DYN_MRD     = 1;        // tMRD = (n+1) = 2 Takte

  EMC_DYN_RD_CFG  = 1;        // "Command delayed strategie" --> benutzt EMCCLKDELAY
  EMC_DYN_RASCAS0 = 0x0202;   //0202 je 2 Takte
  EMC_DYN_CFG0    = ValFor_EMC_DYN_CFG0;

  delay(1000);

  L = 2000;
  while (--L)
  { delay(1);
    EMC_DYN_CTRL = NOP_CMD | 3;          // zuerst NOP Command + alle Takte ein
  }
  delay(20000);
  EMC_DYN_CTRL = PALL_CMD | 3;         // Precharge Command + alle Takte ein
  EMC_DYN_RFSH = 2;                    // erstmal 2*16 = alle 32 CCLK's Refresh ..?
  delay(20000);                        // und das lange...
  EMC_DYN_RFSH = 14;                   // jetzt alle 14*16 CCLK's nen Refresh
  EMC_DYN_CTRL = MODE_CMD | 3;         // jetzt kommt's zum Moderegister setzen
  PDW = (dword*)modesetadr;
  D = *PDW;                            // dummy read von berechneter Adresse
  delay(2000);
  EMC_DYN_CTRL = NORMAL_CMD;           // endlich zum Normalmode kommen

  EMC_DYN_CFG0 = ValFor_EMC_DYN_CFG0 | BufferEnable; // Puffer einschalten
  delay(20000);                        // eigentlich sollte der SDRAM jetzt funktionieren

  SD_CardDetected = false;
  SD_readonly     = false;
  SD_CardSize     = 0;
  SDCardTyp       = 0;

  return D;                            // damit der Compiler mir das nicht wegoptimiert
}




/* ein billiger RAM Test: Bereich ist eigentlich A0000000 .. AFFFFFFF
   aber ab A1000000 friert der uC ein - anstelle Data Abort.
 */
void ExtRamTest(void)
{ dword* PDW;
  dword* PDW0;
  dword* PDEND;

  PDEND = (dword*) CgBWSP;

  PDW0 = PDW = (dword*) ExtRamBegin;
  *PDW0 = 0x4711AFFE;
  ++PDW;

  while ((PDW < PDEND) && (*PDW0 == 0x4711AFFE))
  { *PDW = 0xFFFEFFFE;
    ++PDW;
  }

  *PDW0 = 0xFFFEFFFE;
  while (PDW0 < PDW)
  { if (*PDW0 == 0xFFFEFFFE) *PDW0 = *PDW0 + 0x10002;
    ++PDW0;
  }

  PDW0 = (dword*)ExtRamBegin;
  while ((PDW0 < PDW) && (*PDW0==0)) ++PDW0;
  ExtRamSize = (dword)PDW0 - (dword)ExtRamBegin;
}


/*  ende */
