/* EVB-2478: config.h */

#ifndef SETUPINCLUDED
#define SETUPINCLUDED

/*----------- Port 0 = diverse Peripherie ------------*/
                          /* Pin  Port    Dir    was es ist  */
			  /*=================================*/
#define Q0_00   (2<<0)    /* 94   P0.00    O     TXD3 an JP2 */
#define Q0_01   (2<<2)    /* 96   P0.01    I     RXD3 an JP2 */
#define Q0_02   (1<<4)    /* 202  P0.02    O     TXD0 an V24 */
#define Q0_03   (1<<6)    /* 204  P0.03    I     RXD0 an V24 */
#define Q0_04   (0<<8)    /* 168  P0.04    -     I2S  RxCLK  */
#define Q0_05   (0<<10)   /* 166  P0.05    -     I2S  RxWS   */
#define Q0_06   (0<<12)   /* 164  P0.06    -     I2S  RxDAT  */
#define Q0_07   (0<<14)   /* 162  P0.07    -     I2S  TxCLK  */
#define Q0_08   (0<<16)   /* 160  P0.08    -     I2S  TxWS   */
#define Q0_09   (0<<18)   /* 158  P0.09    -     I2S  TxDAT  */
#define Q0_10   (1<<20)   /*  98  P0.10    O     TXD2  */
#define Q0_11   (1<<22)   /* 100  P0.11    I     RXD2  */
#define Q0_12   (0<<24)   /*  41  P0.12    -     nachgesetzt: SD Karte: CDI  */
#define Q0_13   (1<<26)   /*  45  P0.13    -     USB_UP_LED2  */
#define Q0_14   (2<<28)   /*  69  P0.14    -     USB_CONNECT2 */
#define Q0_15 ((dword)0<<30)   /* 128  P0.15  -  SSP0_SCK  an X12 */

#define Q0_16   (0<<0)    /* 130  P0.16    -     SSP0_SSEL an X12 */
#define Q0_17   (0<<2)    /* 126  P0.17    -     SSP0_MISO an X12 */
#define Q0_18   (0<<4)    /* 124  P0.18    -     SSP0_MOSI an X12 */
#define Q0_19   (0<<6)    /* 122  P0.19    -     I/O KbdClk */
#define Q0_20   (0<<8)    /* 120  P0.20    -     I/O KbdDat */
#define Q0_21   (0<<10)   /* 118  P0.21    -     I/O MausClk */
#define Q0_22   (0<<12)   /* 116  P0.22    -     I/O MausDat */
#define Q0_23   (0<<14)   /*  18  P0.23    A     ADC 0  */
#define Q0_24   (0<<16)   /*  16  P0.24    -     CAP 3 */
#define Q0_25   (0<<18)   /*  14  P0.25    A     ADC 2 */
#define Q0_26   (0<<20)   /*  12  P0.26    A     DAC */
#define Q0_27   (0<<22)   /*  50  P0.27    -     n.b. */
#define Q0_28   (0<<24)   /*  48  P0.28    -     n.b. */
#define Q0_29   (1<<26)   /*  61  P0.29    -     USB1 D+  als USB-Host */
#define Q0_30   (1<<28)   /*  62  P0.30    -     USB1 D-  als USB-Host */
#define Q0_31   (1<<30)   /*  51  P0.31    -     USB2 D+  als USB-Device */

#define ValForPinsel0 ( Q0_00 | Q0_01 | Q0_02 | Q0_03 | Q0_04 | Q0_05 | Q0_06 | Q0_07 | \
                        Q0_08 | Q0_09 | Q0_10 | Q0_11 | Q0_12 | Q0_13 | Q0_14 | Q0_15 )

#define ValForPinsel1 ( Q0_16 | Q0_17 | Q0_18 | Q0_19 | Q0_20 | Q0_21 | Q0_22 | Q0_23 | \
                        Q0_24 | Q0_25 | Q0_26 | Q0_27 | Q0_28 | Q0_29 | Q0_30 | Q0_31 )


/*----------- Port 1 = diverse Peripherie ------------*/
#define Q1_00   (0<<0)     /* 196  P1.00    -     Ethernet TxD0 */
#define Q1_01   (0<<2)     /* 194  P1.01    -     Ethernet TxD1*/
#define Q1_02   (2<<4)     /* 185  P1.02    -     SD MCICLK */
#define Q1_03   (2<<6)     /* 177  P1.03    -     SD MCICMD */
#define Q1_04   (0<<8)     /* 192  P1.04    -     Ethernet TxEn */
#define Q1_05   (2<<10)    /* 156  P1.05    -     SD MCIPWR */
#define Q1_06   (2<<12)    /* 171  P1.06    -     SD MCIDAT0 */
#define Q1_07   (2<<14)    /* 153  P1.07    -     SD MCIDAT1 */
#define Q1_08   (0<<16)    /* 190  P1.08    -     Ethernet CRS */
#define Q1_09   (0<<18)    /* 188  P1.09    -     Ethernet Rx0 */
#define Q1_10   (0<<20)    /* 186  P1.10    -     Ethernet Rx1 */
#define Q1_11   (2<<22)    /* 163  P1.11    -     SD MCIDAT3 */
#define Q1_12   (2<<24)    /* 157  P1.12    -     SD MCIDAT4 */
#define Q1_13   (0<<26)    /* 147  P1.13    -     n.b.   */
#define Q1_14   (0<<28)    /* 184  P1.14    -     Ethernet RxER */
#define Q1_15   (0<<30)    /* 182  P1.15    -     Ethernet RfCLK */

#define Q1_16   (0<<0)     /* 180  P1.16    -     Ethernet MDC */
#define Q1_17   (0<<2)     /* 178  P1.17    -     Ethernet MDIO */
#define Q1_18   (0<<4)     /*  66  P1.18    -     n.b. */
#define Q1_19   (0<<6)     /*  68  P1.19    -     n.b. */
#define Q1_20   (1<<8)     /*  70  P1.20    -     LCD  Grn0 */
#define Q1_21   (1<<10)    /*  72  P1.21    -     LCD  Grn1 */
#define Q1_22   (1<<12)    /*  74  P1.22    -     LCD  Grn2 */
#define Q1_23   (1<<14)    /*  76  P1.23    -     LCD  Grn3 */
#define Q1_24   (1<<16)    /*  78  P1.24    -     LCD  Grn4 */
#define Q1_25   (1<<18)    /*  80  P1.25    -     LCD  Grn5 */
#define Q1_26   (1<<20)    /*  82  P1.26    -     LCD  Blau1 */
#define Q1_27   (1<<22)    /*  88  P1.27    -     LCD  Blau2 */
#define Q1_28   (1<<24)    /*  90  P1.28    -     LCD  Blau3 */
#define Q1_29   (1<<26)    /*  92  P1.29    -     LCD  Blau4 */
#define Q1_30   (2<<28)    /*  42  P1.30    -     USB2 VBUS  */
#define Q1_31   (0<<30)    /*  40  P1.31    -     nachgesetzt SD Karte: WPI */

#define ValForPinsel2 ( Q1_00 | Q1_01 | Q1_02 | Q1_03 | Q1_04 | Q1_05 | Q1_06 | Q1_07 | \
                        Q1_08 | Q1_09 | Q1_10 | Q1_11 | Q1_12 | Q1_13 | Q1_14 | Q1_15 )

#define ValForPinsel3 ( Q1_16 | Q1_17 | Q1_18 | Q1_19 | Q1_20 | Q1_21 | Q1_22 | Q1_23 | \
                        Q1_24 | Q1_25 | Q1_26 | Q1_27 | Q1_28 | Q1_29 | Q1_30 | Q1_31 )


/*----------- Port 2 = diverse Peripherie ------------*/
#define Q2_00   (3<<0)     /* 154  P2.00    -     LCD  Power */
#define Q2_01   (3<<2)     /* 152  P2.01    -     LCD  LE  */
#define Q2_02   (3<<4)     /* 150  P2.02    -     LCD  CLK */
#define Q2_03   (3<<6)     /* 144  P2.03    -     LCD  FP  */
#define Q2_04   (3<<8)     /* 142  P2.04    -     LCD  M   */
#define Q2_05   (3<<10)    /* 140  P2.05    -     LCD  LP  */
#define Q2_06   (3<<12)    /* 138  P2.06    -     LCD  Rot1 */
#define Q2_07   (3<<14)    /* 136  P2.07    -     LCD  Rot2 */
#define Q2_08   (3<<16)    /* 134  P2.08    -     LCD  Rot3 */
#define Q2_09   (3<<18)    /* 132  P2.09    -     LCD  Rot4 */
#define Q2_10   (0<<20)    /* 110  P2.10    -     /Bootlader und EINT0 */
#define Q2_11   (0<<22)    /* 108  P2.11    -     LCD  Clock in */
#define Q2_12   (1<<24)    /* 106  P2.12    -     LCD  Rot0 */
#define Q2_13   (1<<26)    /* 102  P2.13    -     LCD  Blau0 */
#define Q2_14   (0<<28)    /*  91  P2.14    -     Bus: /XCS2 n.b. */
#define Q2_15   (0<<30)    /*  99  P2.15    -     Bus: /XCS3 n.b. */

#define Q2_16   (1<<0)     /*  87  P2.16    -     Bus: CAS */
#define Q2_17   (1<<2)     /*  95  P2.17    -     Bus: RAS */
#define Q2_18   (1<<4)     /*  59  P2.18    -     Bus: CLK0 */
#define Q2_19   (1<<6)     /*  67  P2.19    -     Bus: CLK1 n.b. */
#define Q2_20   (1<<8)     /*  73  P2.20    -     Bus: /DYCS0 */
#define Q2_21   (1<<10)    /*  81  P2.21    -     Bus: /DYCS1 n.b. */
#define Q2_22   (1<<12)    /*  85  P2.22    -     Bus: /DYCS2 n.b. */
#define Q2_23   (1<<14)    /*  64  P2.23    -     Bus: /DYCS3 n.b. */
#define Q2_24   (1<<16)    /*  53  P2.24    -     Bus: /CKE_0 */
#define Q2_25   (1<<18)    /*  54  P2.25    -     Bus: /CKE_1 n.b. */
#define Q2_26   (1<<20)    /*  57  P2.26    -     Bus: /CKE_2 n.b. */
#define Q2_27   (1<<22)    /*  47  P2.27    -     Bus: /CKE_3 n.b. */
#define Q2_28   (1<<24)    /*  49  P2.28    -     Bus: DQM_0 */
#define Q2_29   (1<<26)    /*  43  P2.29    -     Bus: DQM_1 */
#define Q2_30   (1<<28)    /*  31  P2.30    -     Bus: DQM_2 */
#define Q2_31   (1<<30)    /*  39  P2.31    -     Bus: DQM_3 */

#define ValForPinsel4 ( Q2_00 | Q2_01 | Q2_02 | Q2_03 | Q2_04 | Q2_05 | Q2_06 | Q2_07 | \
                        Q2_08 | Q2_09 | Q2_10 | Q2_11 | Q2_12 | Q2_13 | Q2_14 | Q2_15 )

#define ValForPinsel5 ( Q2_16 | Q2_17 | Q2_18 | Q2_19 | Q2_20 | Q2_21 | Q2_22 | Q2_23 | \
                        Q2_24 | Q2_25 | Q2_26 | Q2_27 | Q2_28 | Q2_29 | Q2_30 | Q2_31 )


/*----------- Port 3 = Datenbus, 32 Bit --------------*/
/* alle Bits (1<<xx) */

#define ValForPinsel6   0x55555555
#define ValForPinsel7   0x55555555


/*----------- Port 4 = Adressbus + Steuersignale -----*/
#define Q4_00   (1<<0)     /*  75  P4.00    -     A0   Adressen */
#define Q4_01   (1<<2)     /*  79  P4.01    -     A1   Adressen */
#define Q4_02   (1<<4)     /*  83  P4.02    -     A2   Adressen */
#define Q4_03   (1<<6)     /*  97  P4.03    -     A3   Adressen */
#define Q4_04   (1<<8)     /* 103  P4.04    -     A4   Adressen */
#define Q4_05   (1<<10)    /* 107  P4.05    -     A5   Adressen */
#define Q4_06   (1<<12)    /* 113  P4.06    -     A6   Adressen */
#define Q4_07   (1<<14)    /* 121  P4.07    -     A7   Adressen */
#define Q4_08   (1<<16)    /* 127  P4.08    -     A8   Adressen */
#define Q4_09   (1<<18)    /* 131  P4.09    -     A9   Adressen */
#define Q4_10   (1<<20)    /* 135  P4.10    -     A10  Adressen */
#define Q4_11   (1<<22)    /* 145  P4.11    -     A11  Adressen */
#define Q4_12   (1<<24)    /* 149  P4.12    -     A12  Adressen */
#define Q4_13   (1<<26)    /* 155  P4.13    -     A13  Adressen */
#define Q4_14   (1<<28)    /* 159  P4.14    -     A14  Adressen */
#define Q4_15   (1<<30)    /* 173  P4.15    -     A15  n.b.  */

#define Q4_16   (1<<0)     /* 101  P4.16    -     A16  n.b.  */
#define Q4_17   (1<<2)     /* 104  P4.17    -     A17  n.b.  */
#define Q4_18   (1<<4)     /* 105  P4.18    -     A18  n.b.  */
#define Q4_19   (1<<6)     /* 111  P4.19    -     A19  n.b.  */
#define Q4_20   (2<<8)     /* 109  P4.20    -     I2C  2 (Audio) SDA */
#define Q4_21   (2<<10)    /* 115  P4.21    -     I2C  2 (Audio) SCL */
#define Q4_22   (0<<12)    /* 123  P4.22    -     A  n.b.  */
#define Q4_23   (0<<14)    /* 129  P4.23    -     A  n.b.  */
#define Q4_24   (1<<16)    /* 183  P4.24    -     /OE  */
#define Q4_25   (1<<18)    /* 179  P4.25    -     /WE  */
#define Q4_26   (1<<20)    /* 119  P4.26    -     BLS0 n.b.  */
#define Q4_27   (1<<22)    /* 139  P4.27    -     BLS1 n.b.  */
#define Q4_28   (1<<24)    /* 170  P4.28    -     BLS2, TxD3 n.b.  */
#define Q4_29   (1<<26)    /* 176  P4.29    -     BLS3, RxD3 n.b.  */
#define Q4_30   (1<<28)    /* 187  P4.30    -     /CS0  */
#define Q4_31   (1<<30)    /* 193  P4.31    -     /CS1  */

#define ValForPinsel8 ( Q4_00 | Q4_01 | Q4_02 | Q4_03 | Q4_04 | Q4_05 | Q4_06 | Q4_07 | \
                        Q4_08 | Q4_09 | Q4_10 | Q4_11 | Q4_12 | Q4_13 | Q4_14 | Q4_15 )

#define ValForPinsel9 ( Q4_16 | Q4_17 | Q4_18 | Q4_19 | Q4_20 | Q4_21 | Q4_22 | Q4_23 | \
                        Q4_24 | Q4_25 | Q4_26 | Q4_27 | Q4_28 | Q4_29 | Q4_30 | Q4_31 )

#define ValForPinsel10   0    /* (1<<3) wrde ETM freischalten  */

#define ValForPinsel11   1 | (5<<3)    /* LCD ein, Mode=5=TFT 16 Bit (5:6:5)  */


/* Datenrichtung der GPIO-Pins */
/* IOxDIR steuert bei GPIO-Pins die Richtung: 0=input, 1=output */
/* PINMODExx steuert, ob Pin pullup. pulldown oder nix hat  */
#define IN   0
#define OUT  1
#define pup  0    /* pullup, default */
#define pdn  3    /* pulldown */
#define hiz  2    /* nix, d.h. hochohmig */

#define ValForPINMODE0  0     /* erstmal alles Pullup */
#define ValForPINMODE1  0     /* erstmal alles Pullup */
#define ValForPINMODE2  0     /* erstmal alles Pullup */
#define ValForPINMODE3  0     /* erstmal alles Pullup */
#define ValForPINMODE4  0     /* erstmal alles Pullup */
#define ValForPINMODE5  0     /* erstmal alles Pullup */
#define ValForPINMODE6  0     /* erstmal alles Pullup */
#define ValForPINMODE7  0     /* erstmal alles Pullup */
#define ValForPINMODE8  0     /* erstmal alles Pullup */
#define ValForPINMODE9  0     /* erstmal alles Pullup */


/*----------- externer SDRAM --------------------------
IC = Micron MT48LC4M32B2-7
     1 Mega x 32 Bit x 4 Bnke
     Refreshcount      = 4 K
     ROW Adressing     = 4 K (A0..A11) row length = 12
     COL Adressing     = 256 (A0..A7)  col length = 8
     Bank Adressing    = 4 (BA0, BA1)
     max Clockfrequenz =  143 MHz
     Accesstime        =  5.5 ns (CL=3 ; CAS read latency)


konkret angeschlossen ist der SDRAM so:
RAM A0..A11  an LPC  A0..A11
RAM Pin69 (A12) an LPC A12
RAM BA0      an LPC  A13
RAM BA1      an LPC  A14
RAM CKE      an LPC  CKE_0
RAM CLK      an LPC  CLK_0
RAM CS       an LPC  DYCS0
RAM WE       an LPC  WE
RAM CAS      an LPC  CAS
RAM RAS      an LPC  RAS
RAM DQM0     an LPC  DQM_0
RAM DQM1     an LPC  DQM_1
RAM DQM2     an LPC  DQM_2
RAM DQM3     an LPC  DQM_3
RAM DQ0..31  an LPC  DQ0..31

EMC luft mit CCLK (also EMCCLK=CCLK), macht 60 MHz, also 16.7 ns pro Clocktakt

Mapping laut NXP: (B=Busbreite, L=LoPower, M=Mapping Bits)
32 bit external bus high-performance address mapping (Row, Bank, Column)
(MB = MegaBits)
========================================================================
B L MMM MM
1 0 010 10 = 128 MB (4Mx32),  4 banks, row length = 12, column length = 8   <--?
1 1 010 10 = 128 MB (4Mx32),  4 banks, row length = 12, column length = 8   <--loPower

also Mapping = 0x01010
*/

#define Mapping  (0x0A)              // bin = 01010;

/*--- EMC_DYN_CFG0 = Konfiguration -----*/
#define MD    (01 << 3)              // LoPower SDRAM
#define AM    (Mapping << 7)         // je nach SDRAM-Typ
#define B12   (1 << 12)              // 1 = LoPower, 0 = sonst
#define B14   (1 << 14)              // Busbreite
#define BufferEnable  (1 << 19)      // erst nach Init einschalten

#define ValFor_EMC_DYN_CFG0    (MD | AM | B12 | B14)

/*-------- Kommandos zum EMC -----------*/
#define NORMAL_CMD   (0<<7)   // NORMAL Command
#define MODE_CMD     (1<<7)   // MODE Command
#define PALL_CMD     (2<<7)   // Precharge All Command
#define NOP_CMD      (3<<7)   // NOP Command

/*-------- Mode-Register im SDRAM ------*/
/*
Bit 2..0: Burst length
       0 = 1er burst
       1 = 2er burst
       2 = 4er burst   <--- das benutzen, weil 32 Bit
       3 = 8er burst
       4..6 = verboten
       7 = full page bei M3=0
Bit 3: M3   0=sequential, 1=interleaved  ( 0 benutzen )
Bit 6..4: CAS latency  erlaubt: 1, 2 oder 3  ( 2 benutzen )
Bit 9: Write Burst Mode:
       0=programmierte Burstlnge,    <--- das benutzen
       1=single location access

Der Zugriff ist gemein!! nmlich ohne Daten.
Stattdessen Lesezugriff ber SDRAM-Startadresse+Wert fr Moderegister
also read [0xA0000000 + (WertFrModereg shl 10)]
*/

#define MD_BurstLen     (2 << 0)  // 4er Burst
#define MD_Interleaved  (0 << 3)  // 1 = ein, 0 = aus = sequenziell
#define MD_CAS_Latenz   (2 << 4)  // soll zu EMC_DYN_RASCAS0 passen

#define MD_word     (MD_BurstLen | MD_Interleaved | MD_CAS_Latenz)
#define modesetadr  (0xA0000000 | (MD_word << 10))    // 2 Bit wegen Datenbreite, 8 Bit CAS



extern long Do_Config (void);
extern void ExtRamTest(void);

#endif
